Loading...
Searching...
No Matches
casacore::PoissonFunction< T > Class Template Reference
scimath package (libcasa_scimath) » Functionals_module

More...

`#include <PoissonFunction.h>`

## Public Member Functions

| PoissonFunction ()
| Constructs the PoissonFunction, Defaults: lambda=1.
| PoissonFunction (const T &lambda)
| PoissonFunction (const T &lambda, const T &height)
| PoissonFunction (const PoissonFunction< T > &other)
| Copy constructor (deep copy).
template<class W>
| PoissonFunction (const PoissonFunction< W > &other)
PoissonFunction< T > & | operator= (const PoissonFunction< T > &other)
| Copy assignment (deep copy).
virtual | ~PoissonFunction ()
| Destructor.
virtual T | eval (typename Function< T >::FunctionArg x) const
| Evaluate the Poisson at x.
virtual Function< T > * | clone () const
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::PoissonParam< T >
| PoissonParam ()
| Constructs the Poisson, Defaults: lambda=1.
| PoissonParam (const T &lambda)
| PoissonParam (const T &lambda, const T &height)
| PoissonParam (const PoissonParam< T > &other)
| Copy constructor (deep copy).
template<class W>
| PoissonParam (const PoissonParam< W > &other)
PoissonParam< T > & | operator= (const PoissonParam< T > &other)
| Copy assignment (deep copy).
virtual | ~PoissonParam ()
| Destructor.
virtual uInt | ndim () const
| Returns the number of dimensions of function.
virtual const String & | name () const
| Give name of function.
T | lambda () const
| Get or set lambda.
void | setLambda (const T &lambda)
T | height () const
void | setHeight (const T &height)
Public Member Functions inherited from casacore::Function< T, U >
| Function ()
| Constructors.
| Function (const uInt n)
| Function (const Vector< T > &in)
| Function (const FunctionParam< T > &other)
template<class W, class X>
| Function (const Function< W, X > &other)
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual U | eval (FunctionArg x) const =0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
const T & | operator[] (const uInt n) const
virtual U | operator() () const
| Evaluate this function object at xor at x, y.
virtual U | operator() (const ArgType &x) const
virtual U | operator() (const Vector< ArgType > &x) const
virtual U | operator() (FunctionArg x) const
virtual U | operator() (const ArgType &x, const ArgType &y) const
virtual U | operator() (const ArgType &x, const ArgType &y, const ArgType &z) const
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const Bool & | mask (const uInt n) const
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
FunctionParam< T > & | parameters ()
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Additional Inherited Members

Public Types inherited from casacore::PoissonParam< T >
enum | { LAMBDA , HEIGHT }
| Parameter numbers. More...
Public Types inherited from casacore::Function< T, U >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg
Protected Attributes inherited from casacore::Function< T, U >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::PoissonFunction< T >

A one dimensional Poisson function

### Intended use:

Public interface

### Review Status

Test programs:
  tFunctionHolder

### Prerequisite

- PoissonParam
- Function

### Etymology

A 1-dimensional Poisson.

### Synopsis

A Poisson is described by lambda. The parameters are enumerated by LAMBDA. They have default values of 1.

### Example

PoissonFunction<Double> sf(5.0);
sf(25); // = 5.0
casacore::PoissonFunction::PoissonFunction
PoissonFunction()
Constructs the PoissonFunction, Defaults: lambda=1.
Definition PoissonFunction.h:86

### Template Type Argument Requirements (T)

- T should have standard numerical operators

### Thrown Exceptions

- AipsError if incorrect parameter number specified.

Definition at line 77 of file PoissonFunction.h.

## Constructor & Destructor Documentation

## PoissonFunction() [1/5]

template<class T>

casacore::PoissonFunction< T >::PoissonFunction | ( |  | ) |

inline

Constructs the PoissonFunction, Defaults: lambda=1.

Warning: Could not use default arguments that worked both with gcc and IRIX

Definition at line 86 of file PoissonFunction.h.

References casacore::PoissonParam< T >::PoissonParam().

Referenced by clone(), cloneAD(), cloneNonAD(), operator=(), PoissonFunction(), and PoissonFunction().

## PoissonFunction() [2/5]

template<class T>

casacore::PoissonFunction< T >::PoissonFunction | ( | const T & | lambda | ) |

inline explicit

Definition at line 87 of file PoissonFunction.h.

References casacore::PoissonParam< T >::lambda(), and casacore::PoissonParam< T >::PoissonParam().

## PoissonFunction() [3/5]

template<class T>

casacore::PoissonFunction< T >::PoissonFunction | ( | const T & | lambda,
|  | const T & | height )

inline

Definition at line 89 of file PoissonFunction.h.

References casacore::PoissonParam< T >::height(), casacore::PoissonParam< T >::lambda(), and casacore::PoissonParam< T >::PoissonParam().

## PoissonFunction() [4/5]

template<class T>

casacore::PoissonFunction< T >::PoissonFunction | ( | const PoissonFunction< T > & | other | ) |

inline

Copy constructor (deep copy).

Definition at line 95 of file PoissonFunction.h.

References PoissonFunction(), and casacore::PoissonParam< T >::PoissonParam().

## PoissonFunction() [5/5]

template<class T>
template<class W>

casacore::PoissonFunction< T >::PoissonFunction | ( | const PoissonFunction< W > & | other | ) |

inline

Definition at line 97 of file PoissonFunction.h.

References PoissonFunction(), and casacore::PoissonParam< T >::PoissonParam().

## ~PoissonFunction()

template<class T>

virtual casacore::PoissonFunction< T >::~PoissonFunction | ( |  | ) |

inline virtual

Destructor.

Definition at line 105 of file PoissonFunction.h.

## Member Function Documentation

## clone()

template<class T>

virtual Function< T > * casacore::PoissonFunction< T >::clone | ( |  | ) | const

inline virtual

Return a copy of this object from the heap.

The caller is responsible for deleting this pointer.

Implements casacore::Function< T, U >.

Definition at line 118 of file PoissonFunction.h.

References PoissonFunction().

## cloneAD()

template<class T>

virtual Function< typename FunctionTraits< T >::DiffType > * casacore::PoissonFunction< T >::cloneAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, U >.

Definition at line 119 of file PoissonFunction.h.

References PoissonFunction().

## cloneNonAD()

template<class T>

virtual Function< typename FunctionTraits< T >::BaseType > * casacore::PoissonFunction< T >::cloneNonAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, U >.

Definition at line 121 of file PoissonFunction.h.

References PoissonFunction().

## eval()

template<class T>

virtual T casacore::PoissonFunction< T >::eval | ( | typename Function< T >::FunctionArg | x | ) | const

virtual

Evaluate the Poisson at x.

If a vector is used as the argument only its first element is used.

## operator=()

template<class T>

PoissonFunction< T > & casacore::PoissonFunction< T >::operator= | ( | const PoissonFunction< T > & | other | ) |

inline

Copy assignment (deep copy).

Definition at line 101 of file PoissonFunction.h.

References casacore::PoissonParam< T >::operator=(), and PoissonFunction().

The documentation for this class was generated from the following file:

- scimath/Functionals/PoissonFunction.h